xquery version "1.0";

(: 
 $Id: cmd-model.xql 287 2010-03-25 15:35:06Z ljo $
:)
import module namespace request="http://exist-db.org/xquery/request";
(: import module namespace json="http://www.json.org"; :)

import module namespace cmd-model = "http://spraakbanken.gu.se/clarin/xquery/model"
at "xmldb:exist:///db/clarin/cmd-model.xqm";

(: path="olac/OLAC/The_LINGUIST_List_Language_Resources", q="MDGroup.Actors.Actor", maxdepth=4 :)

declare function local:cmd-model() as item()* {
  let $operation :=  request:get-parameter("operation", $cmd-model:queryModel),
    $cmd-index := request:get-parameter("q", "MDGroup/Actors/Actor"),
    $cmd-index-path := 
    if (fn:contains($cmd-index, ".")) then
      fn:translate($cmd-index, ".", "/") 
    else
      $cmd-index,
    $format := request:get-parameter("format", $cmd-model:responseFormatXml),
    $collection := fn:concat("/db/cmdi-mirror/", request:get-parameter("collection", "silang_data")),
    $max-depth as xs:integer := xs:integer(request:get-parameter("maxdepth", 1))
    return
      if ($operation eq $cmd-model:getCollections) then
	cmd-model:get-collections($collection, $format, $max-depth)
      else if ($operation eq $cmd-model:queryModel) then
	cmd-model:query-model($cmd-index-path, $collection, $format, $max-depth)
    else if ($operation eq $cmd-model:searchRetrieve) then
      let $cql-query := request:get-parameter("query", "MDGroup/Actors/Actor")
      return cmd-model:search-retrieve($cql-query)
    else 
      <error>Unknown operation</error>

};

local:cmd-model()
